package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLConstraint_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLConstraint extends JNIObject  {
	
	/* @generated */
	protected ISLConstraint(long ptr) {
		/*** PROTECTED REGION ID(ISLConstraint_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLConstraint build(long ptr) {
		return new ISLConstraint(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLConstraint_userCode) ENABLED START ***/
	public static ISLConstraint dimEqual(ISLSpace space, int i) {
		if (!space.isMapSpace()) throw new IllegalArgumentException();
		
		ISLConstraint ceq = ISLConstraint.buildEquality(space.copy().toLocalSpace());
		ceq = ceq.setCoefficient(ISLDimType.isl_dim_in, i, 1);
		ceq = ceq.setCoefficient(ISLDimType.isl_dim_out, i, -1);
		return ceq;
	}

	public static ISLConstraint dimGreaterThan(ISLSpace space, int i) {
		if (!space.isMapSpace()) throw new IllegalArgumentException();
		
		ISLConstraint cgt = ISLConstraint.buildInequality(space.copy().toLocalSpace());
		cgt = cgt.setCoefficient(ISLDimType.isl_dim_in, i, 1);
		cgt = cgt.setCoefficient(ISLDimType.isl_dim_out, i, -1);
		cgt = cgt.setConstant(-1);
		return cgt;
	}

	/**
	 * Constructs a constraint (for map) where i-th dimension of input is less than the i-th dimension of output. 
	 * 
	 * @param space
	 * @param i
	 * @return
	 */
	public static ISLConstraint dimLessThan(ISLSpace space, int i) {
		if (!space.isMapSpace()) throw new IllegalArgumentException();
		
		ISLConstraint clt = ISLConstraint.buildInequality(space.copy().toLocalSpace());
		clt = clt.setCoefficient(ISLDimType.isl_dim_in, i, -1);
		clt = clt.setCoefficient(ISLDimType.isl_dim_out, i, 1);
		clt = clt.setConstant(-1);
		return clt;
	}

	public static ISLConstraint dimLessThan(ISLSpace space, int dim,
			int constant) {
		if (!space.isMapSpace()) throw new IllegalArgumentException();
		
		ISLConstraint clt = ISLConstraint.buildInequality(space.copy().toLocalSpace());
		clt = clt.setCoefficient(ISLDimType.isl_dim_in, dim, -1);
		clt = clt.setCoefficient(ISLDimType.isl_dim_out, dim, 1);
		clt = clt.setConstant(-constant);
		return clt;
	}

	public long getCoefficient(ISLDimType type, int pos){
		return getCoefficientVal(type, pos).asLong();
	}
	
	public long getConstant() {
		return getConstantVal().asLong();
	}

	public ISLConstraint setConstant(long v) {
		return setConstant(ISLVal.buildFromLong(getContext(), v));
	}
	
	public int getNbDims(ISLDimType type) {
		return getSpace().dim(type);
	}


	public String javaPrint() {
		StringBuffer res = new StringBuffer();
		String javaPrint = "";
		boolean first = true;

		long cst = getConstant();
		if (cst != 0) {
			first = false;
			javaPrint += cst;
		}

		ISLSpace dims = this.getSpace();

		ISLDimType dimType = ISLDimType.isl_dim_in;
		int n = this.getNbDims(dimType);
		for (int i = 0; i < n; i++) {
			long coef = this.getCoefficient(dimType, i);
			if (coef != 0) {
				if (!first) {
					if (coef < 0)
						javaPrint += " - ";
					else
						javaPrint += " + ";
				} else {
					if (coef < 0)
						javaPrint += "-";
				}
				first = false;
				if (Math.abs(coef) != 1)
					javaPrint += Math.abs(coef);
				javaPrint += dims.getDimName(dimType, i);
			}
		}

		dimType = ISLDimType.isl_dim_out;
		n = this.getNbDims(dimType);
		for (int i = 0; i < n; i++) {
			long coef = this.getCoefficient(dimType, i);
			if (coef != 0) {
				if (!first) {
					if (coef < 0)
						javaPrint += " - ";
					else
						javaPrint += " + ";
				} else {
					if (coef < 0)
						javaPrint += "-";
				}
				first = false;
				if (Math.abs(coef) != 1)
					javaPrint += Math.abs(coef);
				javaPrint += dims.getDimName(dimType, i);
			}
		}

		dimType = ISLDimType.isl_dim_param;
		n = this.getNbDims(dimType);
		for (int i = 0; i < n; i++) {
			long coef = this.getCoefficient(dimType, i);
			if (coef != 0) {
				if (!first) {
					if (coef < 0)
						javaPrint += " - ";
					else
						javaPrint += " + ";
				} else {
					if (coef < 0)
						javaPrint += "-";
				}
				first = false;
				if (Math.abs(coef) != 1)
					javaPrint += Math.abs(coef);
				javaPrint += dims.getDimName(dimType, i);
			}
		}

		dimType = ISLDimType.isl_dim_div;
		n = this.getNbDims(dimType);
		for (int i = 0; i < n; i++) {
			long coef = this.getCoefficient(dimType, i);
			if (coef != 0) {
				if (!first) {
					if (coef < 0)
						javaPrint += " - ";
					else
						javaPrint += " + ";
				} else {
					if (coef < 0)
						javaPrint += "-";
				}
				first = false;
				if (Math.abs(coef) != 1)
					javaPrint += Math.abs(coef) + "*";

				//				JNIISLDiv div = this.getDivAt(i);
				//				javaPrint += div.javaPrint(dims);
			}
		}

		if (javaPrint.isEmpty())
			javaPrint = "0";

		res.append(javaPrint);

		res.append(!isEquality() ? " >= " : " = ");
		res.append("0");
		return res.toString();
	}

	public static ISLConstraint buildEquality(ISLSpace s) {
		return buildEquality(s.toLocalSpace());
	}
	public static ISLConstraint buildInequality(ISLSpace s) {
		return buildInequality(s.toLocalSpace());
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_equality_alloc 
	 * 
	@take ls
	 * @generated
	**/
	 public static ISLConstraint buildEquality(ISLLocalSpace ls) { 
		/*** PROTECTED REGION ID(static_isl_equality_alloc) DISABLED START ***/
		ISLConstraint res;
		
		synchronized(LOCK) {
			checkParameters(ls);
			try {
				res = ISLConstraint.build(ISLNative.isl_equality_alloc(getNativePtr(ls)));
			} finally {
				taken(ls);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_inequality_alloc 
	 * 
	@take ls
	 * @generated
	**/
	 public static ISLConstraint buildInequality(ISLLocalSpace ls) { 
		/*** PROTECTED REGION ID(static_isl_inequality_alloc) DISABLED START ***/
		ISLConstraint res;
		
		synchronized(LOCK) {
			checkParameters(ls);
			try {
				res = ISLConstraint.build(ISLNative.isl_inequality_alloc(getNativePtr(ls)));
			} finally {
				taken(ls);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLConstraint constraint, int format) { 
		/*** PROTECTED REGION ID(static_isl_constraint_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_constraint_to_string(getNativePtr(constraint), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_basic_map_from_constraint 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap toBasicMap() {
		/*** PROTECTED REGION ID(isl_basic_map_from_constraint) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_map_from_constraint(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_from_constraint 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet toBasicSet() {
		/*** PROTECTED REGION ID(isl_basic_set_from_constraint) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_from_constraint(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_constraint_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_constraint_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_constraint_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_constraint_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_get_local_space 
	 * 
	 * @generated
	**/
	public ISLLocalSpace getLocalSpace() {
		/*** PROTECTED REGION ID(isl_constraint_get_local_space) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLLocalSpace.build(ISLNative.isl_constraint_get_local_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_copy 
	 * 
	 * @generated
	**/
	public ISLConstraint copy() {
		/*** PROTECTED REGION ID(isl_constraint_copy) DISABLED START ***/
		ISLConstraint res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLConstraint.build(ISLNative.isl_constraint_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_constraint_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_constraint_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_set_constant_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLConstraint setConstant(int v) {
		/*** PROTECTED REGION ID(isl_constraint_set_constant_si) DISABLED START ***/
		ISLConstraint res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLConstraint.build(ISLNative.isl_constraint_set_constant_si(getNativePtr(this), v));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_set_constant_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLConstraint setConstant(ISLVal v) {
		/*** PROTECTED REGION ID(isl_constraint_set_constant_val) DISABLED START ***/
		ISLConstraint res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLConstraint.build(ISLNative.isl_constraint_set_constant_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_set_coefficient_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLConstraint setCoefficient(ISLDimType type, int pos, int v) {
		/*** PROTECTED REGION ID(isl_constraint_set_coefficient_si) DISABLED START ***/
		ISLConstraint res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLConstraint.build(ISLNative.isl_constraint_set_coefficient_si(getNativePtr(this), type.getValue(), pos, v));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_set_coefficient_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLConstraint setCoefficient(ISLDimType type, int pos, ISLVal v) {
		/*** PROTECTED REGION ID(isl_constraint_set_coefficient_val) DISABLED START ***/
		ISLConstraint res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLConstraint.build(ISLNative.isl_constraint_set_coefficient_val(getNativePtr(this), type.getValue(), pos, getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_is_equal 
	 * 
	 * @generated
	**/
	public boolean isEqual(ISLConstraint constraint2) {
		/*** PROTECTED REGION ID(isl_constraint_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_constraint_is_equal(getNativePtr(this), getNativePtr(constraint2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_is_equality 
	 * 
	 * @generated
	**/
	public boolean isEquality() {
		/*** PROTECTED REGION ID(isl_constraint_is_equality) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_constraint_is_equality(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_is_div_constraint 
	 * 
	 * @generated
	**/
	public boolean isDivConstraint() {
		/*** PROTECTED REGION ID(isl_constraint_is_div_constraint) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_constraint_is_div_constraint(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_is_lower_bound 
	 * 
	 * @generated
	**/
	public boolean isLowerBound(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_constraint_is_lower_bound) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_constraint_is_lower_bound(getNativePtr(this), type.getValue(), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_is_upper_bound 
	 * 
	 * @generated
	**/
	public boolean isUpperBound(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_constraint_is_upper_bound) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_constraint_is_upper_bound(getNativePtr(this), type.getValue(), pos) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_get_constant_val 
	 * 
	 * @generated
	**/
	public ISLVal getConstantVal() {
		/*** PROTECTED REGION ID(isl_constraint_get_constant_val) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_constraint_get_constant_val(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_get_coefficient_val 
	 * 
	 * @generated
	**/
	public ISLVal getCoefficientVal(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_constraint_get_coefficient_val) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_constraint_get_coefficient_val(getNativePtr(this), type.getValue(), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_involves_dims 
	 * 
	 * @generated
	**/
	public boolean involvesDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_constraint_involves_dims) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_constraint_involves_dims(getNativePtr(this), type.getValue(), first, n) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_get_div 
	 * 
	 * @generated
	**/
	public ISLAff getDiv(int pos) {
		/*** PROTECTED REGION ID(isl_constraint_get_div) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLAff.build(ISLNative.isl_constraint_get_div(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_get_dim_name 
	 * 
	 * @generated
	**/
	public String getDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_constraint_get_dim_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_constraint_get_dim_name(getNativePtr(this), type.getValue(), pos);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_get_bound 
	 * 
	 * @generated
	**/
	public ISLAff getBound(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_constraint_get_bound) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLAff.build(ISLNative.isl_constraint_get_bound(getNativePtr(this), type.getValue(), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_constraint_get_aff 
	 * 
	 * @generated
	**/
	public ISLAff getAff() {
		/*** PROTECTED REGION ID(isl_constraint_get_aff) DISABLED START ***/
		ISLAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLAff.build(ISLNative.isl_constraint_get_aff(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLConstraint_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
